Story # 40628 (Closed): As any user, I need a Content Module based on semantic technologies (IKS)
Updated: 2012-10-04 Due date:
Subject: while typing, we should not loose focus
Description

- we have the "midgardStorage" plugin active with autoSave activated.
- while typing, the storage plugin periodically saves the changes to the server
- then, when the reply occurs, the VIE entity seems to be updated.
- this, in turn, triggers a DOM update of the innerHTML (at least that's how it looks like)
- and that's how the editor looses the current cursor position, as the cursor is placed at the start of the editable. And that sucks for the
editor

Associated revisions
Revision 58ea937e - 2012-09-24 10:05 - Sebastian Kurfuerst

[BUGFIX] while typing, the user should not loose the cursor position on autosave

Before this change, the user lost his cursor position after a successful autosave
(which happens automatically in the background).

The reason for this was as follows:
- after a save was complete, the VIE model was updated with server-side data
- this triggered a redraw of the VIE view, which is the content element
- this set the HTML contents of the editable using jQuery's html() function
- this, again, lead to the loss of the cursor position.

As bugfix, we mark model updates after autosaving as silent:

1) CreateJS had to be adjusted accordingly:
https://github.com/bergie/create/commit/ffb40ffd723c700788ea08eb9b7f224eda9d134d
https://github.com/bergie/create/commit/5177c5edb8c171d951a4150bc2d5e7aea722e59a

2) our own code which stores the workspace name of the content element has to do this
   in a silent way.

We not only updated create.js, but also VIE and hallo to be on a consistent version.

Furthermore, we switched to the un-minified version of these tools, as this makes
debugging more easy. These files will be minified by our build-system then.

Finally solved. :-)

Resolves: #41105
Change-Id: I408591e49ab7bad16bef641c81d4a781cc58c8da
History
#1 - 2012-09-20 12:15 - Sebastian Kurfuerst
- Status changed from New to Accepted

#2 - 2012-09-24 10:05 - Gerrit Code Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/14973

#3 - 2012-09-24 10:07 - Sebastian Kurfuerst
- Status changed from Accepted to Under Review

#4 - 2012-09-24 14:03 - Sebastian Kurfuerst
- Status changed from Under Review to Resolved
- Estimated time set to 0.00
- Remaining (hours) set to 0.0

#5 - 2012-10-04 13:50 - Markus Goldbeck
- Status changed from Resolved to Closed
